package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.sort.DummySort;
import de.uni_marburg.powersort.sort.MergeSort;
import de.uni_marburg.powersort.sort.TimSort;
import de.uni_marburg.powersort.data.RandomIntegers;
import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

// TODO: The parameters are way too low. Use for debugging only!
@Fork(1)
@Warmup(iterations = 3)
@Measurement(iterations = 6)
public class BenchmarkJmh {
    /**
     * Quote from JMH:
     * State objects naturally encapsulate the state on which benchmark is working on.
     */
    @State(Scope.Benchmark)
    public static class State1 {
        RandomIntegers d = new RandomIntegers();
        Integer[] a;

        // TODO: This is inaccurate.
        // How to create and use separate arrays for each warmup x iteration x sortAlgorithm ?
        @Setup(Level.Invocation)
        public void setup() {
            a = d.get();
        }
    }

    @BenchmarkMode(Mode.AverageTime)
    @OutputTimeUnit(TimeUnit.MILLISECONDS)
    @Benchmark
    public void rand1DummySort(State1 s) {
        DummySort.sort(s.a, 0, s.a.length, NaturalOrder.INSTANCE, null, 0, 0);
    }

    @BenchmarkMode(Mode.AverageTime)
    @OutputTimeUnit(TimeUnit.MILLISECONDS)
    @Benchmark
    public void rand1TimSort(State1 s) {
        TimSort.sort(s.a, 0, s.a.length, NaturalOrder.INSTANCE, null, 0, 0);
    }

    @BenchmarkMode(Mode.AverageTime)
    @OutputTimeUnit(TimeUnit.MILLISECONDS)
    @Benchmark
    public void rand1MergeSort(State1 s) {
        MergeSort.legacyMergeSort(s.a, NaturalOrder.INSTANCE);
    }
}
